/******************************************************************************
*******************************************************************************
**                                                                           **
**      C Swing - A graphical file and directory maintenance utility         **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: S. J. Brown                                    **
**                                                                           **
**      Modifications by many others; see the documentation for a list       **
**                                                                           **
**      Copyright 1994, Harry Flowers and Foteos Macrides                    **
**                                                                           **
**      Terms of Copyright:  This software may be freely distributed         **
**          and used by anyone, providing the distributor provides it        **
**          free of charge or at a price which only covers distribution      **
**          costs.  It may not be sold.  Note that versions prior to         **
**          V3.7.4 were public domain, and are not subject to these terms.   **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
 
/*
**  swing_12 broadcast trapping
*/
#include <stdio.h>
#include <ctype.h>
#include <ssdef.h>
#include <smgdef.h>
#include <smgmsg.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

broadcasts_ready()
{
    outstanding_broadcasts = TRUE;
}

show_broadcasts()
{
    char msg[1024];
    int ss,i,j,c,row,key,screen;
    unsigned short msg_len;
    int status;
    int length;
    int broadcast_box, ignore_msg;
    short time[4];
    char mess_time[30];
    msg_len = 0;
    broadcast_box = FALSE;
    ignore_msg = FALSE;

    do 
    {
        outstanding_broadcasts = FALSE;
        while(1)
        {
            ss = smg$get_broadcast_message(&paste,DSCA1(msg),&msg_len);

/* Ignore messages that don't have type MSG$_TRMBRDCST 910729-CAK */

            if (ss == SMG$_NONBRDMSG)
            {
                ignore_msg = TRUE;
                continue;
            }

/* If broadcast box has not been displayed yet, and don't have a message that
   should be ignored, then display the broadcast box 910729-CAK */

            if (!broadcast_box && !ignore_msg)
            {
/*              smg$save_physical_screen(&paste,&screen); */
                i = smg$paste_virtual_display(&display_msg, &paste, &MESSAGE_Y, &MESSAGE_X);
                if (i != SS$_NORMAL)
                    panic(i,"paste","show_broadcasts");
                broadcast_box = TRUE;
            }

/* If there are no more messages to process then exit the loop */

            if (ss == SMG$_NO_MORMSG)
                break;
    
            ignore_msg = FALSE;
            broadcasts_rxed = TRUE;
        
            if (ss != SS$_NORMAL)
                panic(ss,"get_broadcast_message","show_broadcasts");
         
            i = sys$gettim(&time[0]);
            if (i != SS$_NORMAL)
                panic(i,"gettim","show_broadcasts");
                        
            length = 0;
            i = sys$asctim(&length,DSCA1(mess_time),&time[0],0);
            if (i != SS$_NORMAL)
                panic(i,"asctim","show_broadcasts");
            
            mess_time[length] = 0;
            sprintf(junk,"----------------------------%s--------------------------------",mess_time);
            junk[MESSAGE_COLS] = 0;
            smg$put_line(&display_msg,DSC1(junk),&1,0);
    
            /*
            **  display message line by line
            **
            **  convert CR LF to 0
            */

            j = 0;
            for (c = 0; c < msg_len; c++)
	    {
                if (isprint(msg[c]))
		    junk[j++] = msg[c];
		else if (j)
		    junk[j++] = ' ';
            }
	    junk[j] = 0;

            /*
            **  strip off trailing spaces
            */
            msg_len = strlen(junk) - 1;
            for (c = msg_len; c > 0; c--)
            {
		if (junk[c] != ' ')
		{
		    junk[c+1] = 0;
		    break;
		}
	    }

            smg$put_line(&display_msg,
                         DSC1(junk),
                         0,
                         0,
                         0,
                         &SMG$M_WRAP_WORD);
        }    

        while(broadcast_box)
        {
            row = 1;	/* in case smg$cursor_row don't work */
            row = smg$cursor_row(&display_msg);
            smg$put_line(&display_msg,
                         DSC1("Press RETURN to continue, M for mail, P for phone "),
                         &0);
    
/*
            key = get_key(ALLOW_CLOCK);
*/
	    key = 0;
            smg$read_keystroke(&keyboard, &key, 0, &1);
            if (outstanding_broadcasts)
		break;

            switch(key)
            {
    case SMG$K_TRM_ASTERISK:
		snapshot();
		break;

    case SMG$K_TRM_TIMEOUT:
		break;

    case SMG$K_TRM_ENTER:
    case SMG$K_TRM_CR:
		goto finished_prompting;
		break;

    case SMG$K_TRM_CTRLW:
    case SMG$K_TRM_CTRLR:
                smg$repaint_screen(&paste);
		break;

    case SMG$K_TRM_UPPERCASE_M:
    case SMG$K_TRM_LOWERCASE_M:
		mail();
		break;

    case SMG$K_TRM_UPPERCASE_P:
    case SMG$K_TRM_LOWERCASE_P:
		phone();
		break;

    default:
	        ding(display_msg);
                break;
	    }
        }

    finished_prompting:;
        smg$erase_line(&display_msg,&row,&1);
        smg$set_cursor_abs(&display_msg,&row,&1);
    } while(outstanding_broadcasts);

    smg$unpaste_virtual_display(&display_msg,&paste);
/*
    smg$restore_physical_screen(&paste,&screen);
*/
}

mail()
{
    execute_cmd("mail ","",TRUE);
}

phone()
{
    execute_cmd("phone ","",TRUE);
}
